from psychopy import visual, core, event
import time
from pylsl import StreamInfo, StreamOutlet, local_clock
import sys

print(sys.version)

## Setup Section
win = visual.Window([400,400], fullscr=True, monitor="testMonitor", units='cm')
rect1 = visual.Rect(win=win, width=1920, height=1080, fillColor="white")

def main():
    # first create a new stream info (here we set the name to MyMarkerStream,
    # the content-type to Markers, 1 channel, irregular sampling rate,
    # and string-valued data) The last value would be the locally unique
    # identifier for the stream as far as available, e.g.
    # program-scriptname-subjectnumber (you could also omit it but interrupted
    # connections wouldn't auto-recover). The important part is that the
    # content-type is set to 'Markers', because then other programs will know how
    #  to interpret the content
    # nominal_srate: The sampling rate (in Hz) as advertised by the data source, if regular (otherwise set to IRREGULAR_RATE). 
    info = StreamInfo(name='MyMarkerStream', type='Markers', channel_count=1, nominal_srate = 0, channel_format='string', source_id='CharacterEvent')

    # next make an outlet
    #outlet = StreamOutlet(info)

    print("now sending keyboard markers...")

    key=event.getKeys()
    while 'escape' not in key:
        key=event.waitKeys()
        if key != []:
            #outlet.push_sample(key)
            rect1.draw()
            win.flip()
            timeStamp = time.perf_counter()
            win.flip()
            timeStamp = timeStamp - time.perf_counter()
            print(timeStamp)

if __name__ == '__main__':
    main()
