#!/usr/bin/env python
# -*- coding: utf-8 -*-

import threading
import time
import numpy as np
from pylsl import StreamInfo, StreamOutlet, local_clock

#setup streaming capture device

print ("Collecting data.....")

# Definitions of basic functions
def ask_user():
    global running
    input("Press ENTER/RETURN to stop acquisition and coil drivers.")
    running = False

def getData():
    global buffer_in
    global send_data
    global seconds
    while running:
        send_data = True
        time.sleep(0.001)

info = StreamInfo(name='MyMarkerStream', type='Markers', channel_count=1, nominal_srate = 0, channel_format='string', source_id='CharacterEvent')
'''
info = StreamInfo(name='BalanceBoard_stream', type='COP', channel_count=4, nominal_srate = sampling_freq_in, source_id='BalanceBoard_stream')
# add info to channels
channels = info.desc().append_child("channels")
for c in ["left_up","left_down","right_up","right_down"]:
    chan = channels.append_child("channel")
    chan.append_child_value("name", c)
    chan.append_child_value("unit", "volts")
    chan.append_child_value("type", "DAQmx_Val_RSE ")
'''
outlet = StreamOutlet(info)  # Broadcast the stream. 

# Start threading to prompt user to stop
thread_user = threading.Thread(target=ask_user)
thread_user.start()

threading.Thread(target=getData).start()
running = True
while running == True:
	if send_data:
		buffer_in_transpose = np.transpose(buffer_in)
		outlet.push_chunk(buffer_in_transpose.tolist())#, timestamp = seconds)
		send_data = False
		#print(np.shape(buffer_in))
		#print(buffer_in)

print("Stop")

## Closing Section
core.quit()