import serial
import time
from pylsl import StreamInfo, StreamOutlet, local_clock

ser = serial.Serial('COM3', 115200)#, timeout = 0.1)


def main():
    # first create a new stream info (here we set the name to MyMarkerStream,
    # the content-type to Markers, 1 channel, irregular sampling rate,
    # and string-valued data) The last value would be the locally unique
    # identifier for the stream as far as available, e.g.
    # program-scriptname-subjectnumber (you could also omit it but interrupted
    # connections wouldn't auto-recover). The important part is that the
    # content-type is set to 'Markers', because then other programs will know how
    #  to interpret the content
    # nominal_srate: The sampling rate (in Hz) as advertised by the data source, if regular (otherwise set to IRREGULAR_RATE). 
    info = StreamInfo(name='MyMarkerStream', type='Markers', channel_count=1, nominal_srate = 0, channel_format='string', source_id='CharacterEvent')

    # next make an outlet
    outlet = StreamOutlet(info)

    print("now sending markers...")

    while True:
        ser_bytes = (ser.read()).decode("utf-8")
        #print(ser_bytes)
        if len(ser_bytes) > 0:
            seconds = local_clock()
            for ser_byte in ser_bytes: 
                #dataSerial = ser_bytes[0]
                outlet.push_sample(ser_byte,seconds)
                print(ser_bytes)
        #        print(ser_byte)
                #outlet.push_sample(dataSerial)
        #else:
        #    outlet.push_sample("x")

if __name__ == '__main__':
    main()
