import pyautogui
import keyboard
import time
from pylsl import StreamInlet, resolve_stream

def main():
	# first resolve an EEG stream on the lab network
	print("monitor resolution:")
	monWidth, monHeight = pyautogui.size()
	print(pyautogui.size())
	mouseFreq = 100.0
	timeStampSys = time.time() + (1.0/mouseFreq)

	print("looking for an tobii eyetracker stream...")
	streams = resolve_stream('type', 'gaze')
	print(streams[0].name())
	print(streams[0].type())
	print(streams[0].nominal_srate())
	print(streams[0].channel_count())

	# create a new inlet to read from the stream
	inlet = StreamInlet(streams[0])
	'''	[ "left_on_display_x", "left_on_display_y", 
          "left_origin_x", "left_origin_y", "left_origin_z", 
          "left_pupil_diam",
          "right_on_display_x", "right_on_display_y",
          "right_origin_x", "right_origin_y", "right_origin_z",
          "right_pupil_diam"]
	'''
	timeStamp = time.time() + (1.0/mouseFreq)
	while True:
		dummy = inlet.pull_chunk()
		sample, timestamp = inlet.pull_sample()
		#print(sample[0]*monWidth, sample[1]*monHeight)
		if timeStampSys < time.time():
			t0 = time.time()
			timeStampSys = time.time() + (1.0/mouseFreq)
			try:
				pyautogui.moveTo(sample[0]*monWidth, sample[1]*monHeight)
			except:
				pass
			if keyboard.is_pressed('1') or keyboard.is_pressed('2'): # it will stop working by clicking q you can change to to any key
				break
			print("{}".format(time.time() - t0))
			
if __name__ == '__main__':
	main()
