#!/usr/bin/env python
# -*- coding: utf-8 -*-
import sys
print(sys.version)

from psychopy import core
from psychopy import event
from psychopy import visual
import serial
import time
import pyautogui
from pylsl import StreamInlet, resolve_stream

win = visual.Window([1000,1000], fullscr=False, winType = "pyglet", monitor="testMonitor",color=(-1, -1, -1), units='pix', 
waitBlanking=False)

eyePos = visual.Circle(
    win=win,
    units="pix",
    radius=10,
    edges=32,
   	lineWidth=1,
	color = 'black',
	lineColor='forestgreen', 
	fillColor='lawngreen'
    #lineColor=[-1, -1, -1]
)

print("monitor resolution:")
monWidth, monHeight = pyautogui.size()

print("looking for an tobii eyetracker stream...")
streams = resolve_stream('type', 'gaze')
print(pyautogui.size())
print(streams[0].name())
print(streams[0].type())
print(streams[0].nominal_srate())
print(streams[0].channel_count())

# create a new inlet to read from the stream
inlet = StreamInlet(streams[0])
'''	[ "left_on_display_x", "left_on_display_y", 
      "left_origin_x", "left_origin_y", "left_origin_z", 
      "left_pupil_diam",
      "right_on_display_x", "right_on_display_y",
      "right_origin_x", "right_origin_y", "right_origin_z",
      "right_pupil_diam"]
'''

eyePos.draw()
win.flip()
core.wait(1)
timeStamp = time.time() + (1.0/60.0)
while 'escape' not in event.getKeys() and 'esc' not in event.getKeys():
	sample, timestamp = inlet.pull_sample()
	sample[0] = (sample[0]*monWidth)  - (monWidth/2) 
	sample[1] =((sample[1]*monHeight) - (monHeight/2)) *-1
	#print(sample[0], sample[1])
	if timeStamp < time.time():
		timeStamp = time.time() + (1.0/60.0)
		try:
			eyePos.pos = (sample[0], sample[1])
			eyePos.draw()
			win.flip()
		except:
			pass