import pyaudio
import threading
import numpy as np
from pylsl import StreamInfo, StreamOutlet, local_clock

#AUDIO INPUT
CHANNELS = 1
RATE = 44100
CHUNKSIZE = 1024*8
running = True
send_data = False

# initialize portaudio
p = pyaudio.PyAudio()
stream = p.open(format=pyaudio.paInt16, channels=CHANNELS, rate=RATE, input=True, frames_per_buffer=CHUNKSIZE)
info = StreamInfo(name='Mic', type='voice', channel_count=CHANNELS, nominal_srate = RATE, source_id='Microphone_stream')
outlet = StreamOutlet(info)  # Broadcast the stream. 

# Definitions of basic functions
def ask_user():
    global running
    input("Press ENTER/RETURN to stop acquisition and coil drivers.")
    running = False

def getMicData():
    global buffer_in
    global send_data
    global seconds
    while running:
        buffer_in = stream.read(CHUNKSIZE)
        seconds = local_clock()
        send_data = True

# Start threading to prompt user to stop
thread_user = threading.Thread(target=ask_user, daemon=True)
thread_user.start()

buffer_in = []
while running:
    if send_data:
        npData = np.frombuffer(buffer_in, dtype=np.int16)
        #print(np.size(npData))
        outlet.push_chunk(npData, timestamp = seconds)
        send_data = False
        #print(np.shape(buffer_in))
        #print(buffer_in)    
    
# close stream
stream.stop_stream()
stream.close()
p.terminate()