#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import threading
import time
#import numpy as np
import fpclient
import sys
from pylsl import StreamInfo, StreamOutlet, local_clock
from iteration_utilities import flatten

print(sys.version)

#setup streaming capture device

print ("Collecting data.....")
freq = 100

# Definitions of basic functions
def ask_user():
    global running
    input("Press ENTER/RETURN to stop acquisition and coil drivers.")
    running = False

def sendLSLFrames():
	global buffer_in
	stampi=0
	stamp = time.perf_counter()
	while running:
		time.sleep((1.0/freq) - 0.002)
		while time.perf_counter() < stamp:
			time.sleep(0)
			pass
		stamp = time.perf_counter() + (1.0/freq)
		try:
			flat_list = list(flatten(buffer_in))
			#multiplied_list = [element * 1000 for element in flat_list]
			outlet.push_chunk(flat_list)
		except:
			pass
			#print("data not ready")
		
def getData():
	global buffer_in
	global serverTime
	global info
	global outlet
	global send_data
	buildStreamInfo = True

	tSync = 0
	nSync = 0
	client = fpclient.FpClient(server)      # make a new NDI First Principles client
	client.sendCommand("StreamFrames FrequencyDivisor:1")
	
	while running:
		# main data retrieval loop
		buffer_in, serverTime, arrivalTime, sampleNr = client.getRealtimePosition()
		#client.show()
		#print(round(stamp- arrivalTime,5))
		if buildStreamInfo and len(buffer_in) > 1:
			print("build LSL")
			flat_list = list(flatten(buffer_in))
			print(len(flat_list))
			print(flat_list)
			info = StreamInfo(name='optotrackStream', 
								type='position', 
								channel_count=len(flat_list), 
								nominal_srate = freq,
								source_id='optotrackLSLStream')
			channels = info.desc().append_child("channels")
			i=0
			for c in (["x", "y", "z"] *int(len(flat_list)/3)) :
				chan = channels.append_child("channel")
				chan.append_child_value("name", c + str(int(i/3) +1))
				chan.append_child_value("unit", "mm")
				chan.append_child_value("type", "markerPosition")
				i+=1
			outlet = StreamOutlet(info)
			buildStreamInfo = False
		if len(buffer_in) > 1:
			time.sleep(0)

if len(sys.argv) > 1:
	server = sys.argv[1]
else:
	server = "localhost"
	server = "100.1.1.2"
print("fp server: ", server)

info = []
outlet = []

# Start threading to prompt user to stop
thread_user = threading.Thread(target=ask_user)
thread_user.start()
running = True
send_data = False

threading.Thread(target=getData).start()
threading.Thread(target=sendLSLFrames).start()

while running == True:
	# if send_data:
	# 	flat_list = list(flatten(buffer_in))
	# 	multiplied_list = [element * 1000 for element in flat_list]
	# 	outlet.push_sample(multiplied_list)#, serverTime)
	# 	send_data = False
	time.sleep(0.1)

print("Stop")
