#!/usr/bin/env python
# -*- coding: utf-8 -*-

import threading
import time
import numpy as np
from pylsl import StreamInfo, StreamOutlet, local_clock

#setup streaming capture device
import asyncio
from bleak import BleakClient
import threading
 
address       = "A0:9E:1A:71:96:37"
model_uid     = "00002a24-0000-1000-8000-00805f9b34fb"
battery_uid   = "00002a19-0000-1000-8000-00805f9b34fb"
heartbeat_uid = "00002a37-0000-1000-8000-00805f9b34fb"
 
print ("Collecting data.....")

# Definitions of basic functions
def ask_user():
    global running
    input("Press ENTER/RETURN to stop acquisition and coil drivers.")
    running = False

def on_data(data):
    outlet.push_chunk([data])
    print("Data received")
    print(data)

def on_data2(sender, data):
    outlet.push_chunk([data[1]])
    print("Data received")
    print(data[1])

#def getData():
async def run(address):
    async with BleakClient(address) as client:
        model = await client.read_gatt_char(model_uid)
        model = model.decode("utf-8")
        battery = await client.read_gatt_char(battery_uid)
        battery = battery[0]
        print("device: {:s}, battery: {:d}%, press enter to stop".format(model, battery))
 
        #await client.start_notify(heartbeat_uid, lambda sender, data: print("\r{:d} bpm ".format(data[1]), end=""))
        #await client.start_notify(heartbeat_uid, lambda sender, data: on_data(data[1]))
        await client.start_notify(heartbeat_uid, on_data2)
        while await client.is_connected() and running:
            await asyncio.sleep(1)

info = StreamInfo(name='HeartRate_stream', type='BPM', channel_count=1, nominal_srate = 1, source_id='HeartRate_stream')
'''
info = StreamInfo(name='MyMarkerStream', type='Markers', channel_count=1, nominal_srate = 0, channel_format='string', source_id='CharacterEvent')
# add info to channels
channels = info.desc().append_child("channels")
for c in ["left_up","left_down","right_up","right_down"]:
    chan = channels.append_child("channel")
    chan.append_child_value("name", c)
    chan.append_child_value("unit", "volts")
    chan.append_child_value("type", "DAQmx_Val_RSE ")
'''
outlet = StreamOutlet(info)  # Broadcast the stream. 

# Start threading to prompt user to stop
thread_user = threading.Thread(target=ask_user)
thread_user.start()

threading.Thread(target=asyncio.run, args=(run(address),)).start() # mix of paradigms: event loop in background
running = True

while running == True:
	pass

print("Stop")
