#!/usr/bin/env python
# -*- coding: utf-8 -*-

import threading
import time
import numpy as np
from psychopy import visual 
from psychopy import core, event
from pylsl import StreamInfo, StreamOutlet, local_clock

## Setup Section
win = visual.Window([720,720], fullscr=False, monitor="testMonitor", units='cm')

# append this stimulus to the list of prepared stimuli
vlc_movies = []
my_movies = ['StressFilm.mp4']#path to your movies from this directory

for movie in my_movies:
    mov = visual.VlcMovieStim(win, movie,
    #size=600,  # set as `None` to use the native video size
    pos=[0, 0],  # pos specifies the /center/ of the movie stim location
    flipVert=False,  # flip the video picture vertically
    flipHoriz=False,  # flip the video picture horizontally
    loop=False,  # replay the video when it reaches the end
    autoStart=True)  # start the video automatically when first drawn
    vlc_movies.append(mov)

# Definitions of basic functions
def ask_user():
    global running
    input("Press ENTER/RETURN to stop acquisition and coil drivers.")
    running = False

def playMovie(thisMovie):
    global buffer_in
    global send_data
    global seconds
    global running
    
    while running and thisMovie.status != visual.FINISHED:
        thisMovie.draw()
        win.flip()
        buffer_in = thisMovie.frameIndex
        send_data = True
        #time.sleep(0.002)
        
info = StreamInfo(name='MyMarkerStream', type='Markers', channel_count=1, nominal_srate = 0, channel_format='string', source_id='CharacterEvent')
'''
info = StreamInfo(name='BalanceBoard_stream', type='COP', channel_count=4, nominal_srate = sampling_freq_in, source_id='BalanceBoard_stream')
# add info to channels
channels = info.desc().append_child("channels")
for c in ["left_up","left_down","right_up","right_down"]:
    chan = channels.append_child("channel")
    chan.append_child_value("name", c)
    chan.append_child_value("unit", "volts")getWebcamData
    chan.append_child_value("type", "DAQmx_Val_RSE ")
'''
#outlet = StreamOutlet(info)  # Broadcast the stream. 

# Start threading to prompt user to stop
thread_user = threading.Thread(target=ask_user)
#thread_user.start()

running = True
send_data = False
thread_video = threading.Thread(target=playMovie(vlc_movies[0]))
thread_video.start()

print("playing video....")
while running:
    print(send_data)
    if send_data:
        outlet.push_sample(buffer_in)#, timestamp = seconds)
        print(buffer_in)
        send_data = False
        #print(np.shape(buffer_in))
        #print(buffer_in)

print("Stop")

## Closing Section
core.quit()